﻿// ---------------------------------------------------------------------
// This source file is (C) 2010-2013 Sanders Technology http://www.sanderstechnology.com
// Please review the copyright terms in the Conditions.txt file accompanying this source code
// Author:  Rob Sanders
// Email:   rob.sanders@gmail.com
// Created: Thursday, 10 February 2011, Last Modified: 23 October, 2012
// ---------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Common
{
    public class BaseLogProvider
    {
        #region Protected Functions

        /// <summary>
        /// 
        /// </summary>
        /// <param name="message"></param>
        protected static string FormatMessage(string message)
        {
            return String.Format("{0}: {1}", DateTime.Now, message);
        }

        /// <summary>
        /// Formats a Message to write
        /// </summary>
        /// <param name="details"></param>
        /// <returns></returns>
        protected static string FormatMessage(LogDetails details)
        {
            StringBuilder logMessage = new StringBuilder();

            if (!string.IsNullOrEmpty(details.Title))
            {
                logMessage.AppendFormat("Title: {0}\r\n", details.Title);
            }

            if (int.MinValue != details.Priority)
            {
                logMessage.AppendFormat("Priority: {0}\r\n", details.Priority);
            }

            if (!string.IsNullOrEmpty(details.Message))
            {
                logMessage.AppendFormat("Message(s): \r\n{0}\r\n", details.Message);
            }

            if (!string.IsNullOrEmpty(details.AppDomainName))
            {
                logMessage.AppendFormat("Source(s): {0}\r\n", details.AppDomainName);
            }

            if (!string.IsNullOrEmpty(details.ErrorMessages))
            {
                logMessage.AppendFormat("Error Message(s): \r\n{0}\r\n", details.ErrorMessages);
            }

            if (int.MinValue != details.EventId)
            {
                logMessage.AppendFormat("EventId: {0}\r\n", details.EventId);
            }

            if (!string.IsNullOrEmpty(details.LoggedSeverity))
            {
                logMessage.AppendFormat("LoggedSeverity: {0}\r\n", details.LoggedSeverity);
            }

            if (!string.IsNullOrEmpty(details.MachineName))
            {
                logMessage.AppendFormat("MachineName: {0}\r\n", details.MachineName);
            }

            if (!string.IsNullOrEmpty(details.ManagedThreadName))
            {
                logMessage.AppendFormat("ManagedThreadName: {0}\r\n", details.ManagedThreadName);
            }

            if (!string.IsNullOrEmpty(details.ProcessName))
            {
                logMessage.AppendFormat("ProcessName: {0}\r\n", details.ProcessName);
            }

            if (!string.IsNullOrEmpty(details.ProcessId))
            {
                logMessage.AppendFormat("ProcessId: {0}\r\n", details.ProcessId);
            }

            if (DateTime.MinValue != details.Timestamp)
            {
                logMessage.AppendFormat("TimeStamp: {0}\r\n", details.Timestamp.ToString());
            }

            if (!string.IsNullOrEmpty(details.TimestampString))
            {
                logMessage.AppendFormat("TimeStampString: {0}\r\n", details.TimestampString);
            }

            if (!string.IsNullOrEmpty(details.Win32ThreadId))
            {
                logMessage.AppendFormat("Win32ThreadId: {0}\r\n", details.Win32ThreadId);
            }

            return logMessage.ToString();
        }

        #endregion
    }
}
