﻿// ---------------------------------------------------------------------
// This source file is (C) 2010-2013 Sanders Technology http://www.sanderstechnology.com
// Please review the copyright terms in the Conditions.txt file accompanying this source code
// Author:  Rob Sanders
// Email:   rob.sanders@gmail.com
// Created: Thursday, 10 February 2011, Last Modified: 23 October, 2012
// ---------------------------------------------------------------------
using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Diagnostics;

namespace ThreadManager.UnitTests
{
    [TestClass]
    public class SynchronousExecution
    {
        [TestMethod]
        public void TestSynchExecution()
        {
            List<ThreadWorkPackage> packages = TestCommon.GetWorkList("Basic Test", 40, 0, new ThreadWorkPackage.ExecutionEvent(callback));
            ThreadPoolManager mgr = new ThreadPoolManager();
            mgr.BeginExecution(packages, true);
        }

        /// <summary>
        /// Basic Callback
        /// </summary>
        /// <param name="context"></param>
        protected void callback(ThreadWorkPackage context)
        {          
            Trace.WriteLine(String.Format("{0}:{1}", context.PackageSeries, context.PackageId));
        }
    }
}
